Yusef.addPlugin
(
    'translation',
    function Yusef_plugins_translation()
    {
        var self                = this;
        var config              = {domain: 'service'}; // TODO: should support different domains
        var translator          = new Translator( config );
        var original_           = translator.underscore;
        
        Yusef.addSectionListener( 'translation', translator.sendClientScript );
        
        Yusef.extend
        (
            'addSectionListener',
            function extendedAddSectionListener( section, method, options )
            {
                var newMethod = function( connection )
                {
                    modifyTranslatorForTesting( connection, translator );
                    translator.setLanguagesFromHttp( connection );
                    var output = method.apply( this, arguments );
                    if( !connection.closed 
                     && output && typeof(output.substring) == 'function' )
                    {
                        //var langs = (connection.request.getRequestHeader( 'Accept-Language' )||[])[0];
                        return translator.translate( output/*, langs*/ );
                    }
                    else
                    {
                        return output;
                    }
                };

                return extendedAddSectionListener.proceed( section, newMethod, options );
            }
        );

        if (window.markuper)
        {
            window.markuper.evaluator.registerFilter('getvar', function(input, expr) {
                return '"'+input+'" as ' + expr;
            });
        }
                
        window._ = translator.underscore;
        
        function modifyTranslatorForTesting( connection, translator )
        {
            if( !connection.request.queryItems.trans ) { return; }
            
            if( connection.request.queryItems.trans[0] == 'large' )
            {
                translator.underscore = function()
                {
                    var string = original_.apply( translator, arguments );
                    return string+string;
                }
                window._ = translator.underscore;
            }
            
            if( connection.request.queryItems.trans[0] == 'small' )
            {
                translator.underscore = function()
                {
                    var string = original_.apply( translator, arguments );
                    return string[0];
                }
                window._ = translator.underscore;
            }
        }
    }
);